Index: mythcontrols/keybindings.cpp
===================================================================
--- mythcontrols/keybindings.cpp	(revision 10604)
+++ mythcontrols/keybindings.cpp	(working copy)
@@ -26,10 +26,7 @@
  * and the UI.
  */
 
-/* QT */
 #include <qstring.h>
-
-/* MythTV */
 #include <mythtv/mythcontext.h>
 #include <mythtv/mythdialogs.h>
 
@@ -38,22 +35,69 @@
 #include "keybindings.h"
 
 
-
 KeyBindings::KeyBindings(const QString & hostname)
 {
-    this->hostname() = hostname;
-    loadManditoryBindings();
+    m_HostName = hostname;
+    LoadMandatoryBindings();
 
-    retrieveContexts();
-    retrieveJumppoints();
+    RetrieveContexts();
+    RetrieveJumppoints();
 }
 
+QStringList * KeyBindings::GetKeyActions(const QString &key) const
+{
+    QStringList *strings;
+    const ActionList & al = m_ActionSet.GetActions(key);
 
+    if (al.size() > 0)
+        strings = new QStringList();
+    else
+        return NULL;
 
-ActionID * KeyBindings::conflicts(const QString & context_name,
+    for (size_t i = 0; i < al.size(); i++)
+        strings->push_back(al[i].action());
+
+    return strings;
+}
+
+
+QString KeyBindings::GetContext(const QString & key, const QString & action,
+                                size_t anum) const
+{
+    /* The cases where unknown is returned should never happen.  If
+     * you see an unknown context, do not approach it.  Call the
+     * police immediatly. */
+    const ActionList &al = m_ActionSet.GetActions(key);
+    int offset = al.size() - anum;
+
+    if (offset < 0)
+        return "UNKNOWN";
+    else if (al[anum].action() != action)
+        return "UNKNOWN";
+    if (anum < al.size())
+        return al[anum].context();
+    else
+        return "UNKNOWN";
+}
+
+QString KeyBindings::GetAction(const QString & key,
+                               const QString & context) const
+{
+    const ActionList &al = m_ActionSet.GetActions(key);
+
+    for (size_t i = 0; i < al.size(); i++)
+    {
+        if (al[i].context() == context)
+            return al[i].action();
+    }
+    return "UNKNOWN";
+}
+
+
+ActionID * KeyBindings::Conflicts(const QString & context_name,
                                   const QString & key, int &level) const
 {
-    const ActionList &ids = actionset.getActions(key);
+    const ActionList &ids = m_ActionSet.GetActions(key);
 
     /* trying to bind a jumppoint to an already bound key */
     if ((context_name == JUMP_CONTEXT) && (ids.count() > 0))
@@ -84,24 +128,25 @@
 
 
 /* method description in header */
-bool KeyBindings::removeActionKey(const QString & context_name,
+bool KeyBindings::RemoveActionKey(const QString & context_name,
                                   const QString & action_name,
                                   const QString & key)
 {
 
     ActionID id(context_name, action_name);
 
-    /* dont remove the last manditory binding */
-    if (getManditoryBindings().contains(id)&&(actionset.getKeys(id).count()<2))
+    /* dont remove the last mandatory binding */
+    if (getMandatoryBindings().contains(id) &&
+        (m_ActionSet.GetKeys(id).count()<2))
         return false;
     else
-        return this->actionset.remove(id,key);
+        return this->m_ActionSet.Remove(id,key);
 }
 
 
 
 /* method description in header */
-void KeyBindings::commitAction(const ActionID & id)
+void KeyBindings::CommitAction(const ActionID & id)
 {
 
     MSqlQuery query(MSqlQuery::InitCon());
@@ -112,8 +157,8 @@
 
     if (query.isConnected())
     {
-        QString keys = actionset.keyString(id);
-        query.bindValue(":HOSTNAME", this->getHostname());
+        QString keys = m_ActionSet.KeyString(id);
+        query.bindValue(":HOSTNAME", m_HostName);
         query.bindValue(":CONTEXT", id.context());
         query.bindValue(":ACTION", id.action());
         query.bindValue(":KEYLIST", keys);
@@ -131,7 +176,7 @@
 
 
 
-void KeyBindings::commitJumppoint(const ActionID &id)
+void KeyBindings::CommitJumppoint(const ActionID &id)
 {
 
     MSqlQuery query(MSqlQuery::InitCon());
@@ -142,8 +187,8 @@
 
     if (query.isConnected())
     {
-        QString keys = actionset.keyString(id);
-        query.bindValue(":HOSTNAME", this->getHostname());
+        QString keys = m_ActionSet.KeyString(id);
+        query.bindValue(":HOSTNAME", this->m_HostName);
         query.bindValue(":DESTINATION", id.action());
         query.bindValue(":KEYLIST", keys);
 
@@ -161,20 +206,22 @@
 
 
 
-void KeyBindings::commitChanges(void)
+void KeyBindings::CommitChanges(void)
 {
-    ActionList modified = actionset.getModified();
+    ActionList modified = m_ActionSet.GetModified();
 
     while (modified.size() > 0)
     {
         ActionID id = modified.front();
 
         /* commit either a jumppoint or an action */
-        if (id.context() == JUMP_CONTEXT) commitJumppoint(id);
-        else commitAction(id);
+        if (id.context() == JUMP_CONTEXT)
+            CommitJumppoint(id);
+        else
+            CommitAction(id);
 
         /* tell the action set that the action is no longer modified */
-        actionset.unmodify(id);
+        m_ActionSet.Unmodify(id);
 
         modified.pop_front();
     }
@@ -182,7 +229,7 @@
 
 
 
-void KeyBindings::retrieveJumppoints()
+void KeyBindings::RetrieveJumppoints()
 {
     MSqlQuery query(MSqlQuery::InitCon());
 
@@ -192,7 +239,7 @@
                       "FROM jumppoints "
                       "WHERE hostname = :HOSTNAME "
                       "ORDER BY destination ;");
-        query.bindValue(":HOSTNAME", this->getHostname());
+        query.bindValue(":HOSTNAME", m_HostName);
     }
 
     query.exec();
@@ -202,18 +249,17 @@
         ActionID id(JUMP_CONTEXT, query.value(0).toString());
 
         if (query.value(1).toString().isEmpty())
-        {
-            actionset.addAction(id, query.value(0).toString(),
-                                query.value(2).toString());
-        }
-        else actionset.addAction(id,query.value(1).toString(),
-                                 query.value(2).toString());
+            m_ActionSet.AddAction(id, query.value(0).toString(),
+                                  query.value(2).toString());
+        else
+            m_ActionSet.AddAction(id,query.value(1).toString(),
+                                  query.value(2).toString());
     }
 }
 
 
 
-void KeyBindings::retrieveContexts()
+void KeyBindings::RetrieveContexts()
 {
 
     MSqlQuery query(MSqlQuery::InitCon());
@@ -225,7 +271,7 @@
                       "WHERE hostname = :HOSTNAME "
                       "ORDER BY context,action ;");
 
-        query.bindValue(":HOSTNAME", this->getHostname());
+        query.bindValue(":HOSTNAME", this->m_HostName);
     }
 
     query.exec();
@@ -233,45 +279,45 @@
     for (query.next(); query.isValid(); query.next())
     {
         ActionID id(query.value(0).toString(), query.value(1).toString());
-        this->actionset.addAction(id, query.value(2).toString(),
-                                  query.value(3).toString());
+        this->m_ActionSet.AddAction(id, query.value(2).toString(),
+                                    query.value(3).toString());
     }
 }
 
 
 
-void KeyBindings::loadManditoryBindings(void)
+void KeyBindings::LoadMandatoryBindings(void)
 {
-    if (getManditoryBindings().empty())
+    if (m_MandatoryBindings.empty())
     {
-        manditoryBindings().append(ActionID(GLOBAL_CONTEXT, "DOWN"));
-        defaultKeys().append("Down");
+        m_MandatoryBindings.append(ActionID(GLOBAL_CONTEXT, "DOWN"));
+        m_DefaultKeys.append("Down");
 
-        manditoryBindings().append(ActionID(GLOBAL_CONTEXT, "UP"));
-        defaultKeys().append("Up");
+        m_MandatoryBindings.append(ActionID(GLOBAL_CONTEXT, "UP"));
+        m_DefaultKeys.append("Up");
 
-        manditoryBindings().append(ActionID(GLOBAL_CONTEXT, "LEFT"));
-        defaultKeys().append("Left");
+        m_MandatoryBindings.append(ActionID(GLOBAL_CONTEXT, "LEFT"));
+        m_DefaultKeys.append("Left");
 
-        manditoryBindings().append(ActionID(GLOBAL_CONTEXT, "RIGHT"));
-        defaultKeys().append("Right");
+        m_MandatoryBindings.append(ActionID(GLOBAL_CONTEXT, "RIGHT"));
+        m_DefaultKeys.append("Right");
 
-        manditoryBindings().append(ActionID(GLOBAL_CONTEXT, "ESCAPE"));
-        defaultKeys().append("Esc");
+        m_MandatoryBindings.append(ActionID(GLOBAL_CONTEXT, "ESCAPE"));
+        m_DefaultKeys.append("Esc");
 
-        manditoryBindings().append(ActionID(GLOBAL_CONTEXT, "SELECT"));
-        defaultKeys().append("Return,Enter,Space");
+        m_MandatoryBindings.append(ActionID(GLOBAL_CONTEXT, "SELECT"));
+        m_DefaultKeys.append("Return,Enter,Space");
     }
 }
 
 
 
-bool KeyBindings::hasManditoryBindings(void) const
+bool KeyBindings::HasMandatoryBindings(void) const
 {
-    ActionList manlist = getManditoryBindings();
+    ActionList manlist = getMandatoryBindings();
     for (size_t i = 0; i < manlist.count(); i++)
     {
-        if (actionset.getKeys(manlist[i]).isEmpty())
+        if (m_ActionSet.GetKeys(manlist[i]).isEmpty())
             return false;
     }
 
Index: mythcontrols/actionset.cpp
===================================================================
--- mythcontrols/actionset.cpp	(revision 10604)
+++ mythcontrols/actionset.cpp	(working copy)
@@ -36,21 +36,21 @@
 
 
 /* method description in header */
-bool ActionSet::add(const ActionID &id, const QString &key)
+bool ActionSet::Add(const ActionID &id, const QString &key)
 {
     Action *a;
 
     /* get the action; make sure it exists before doing anything */
-    if ((a = this->action(id)))
+    if ((a = this->GetAction(id)))
     {
 
         /* if the key was added, mark this action as modified, and
            update the key map */
-        if (a->addKey(key))
+        if (a->AddKey(key))
         {
-            ActionList &ids = _keymap[key];
+            ActionList &ids = m_KeyMap[key];
             ids.push_back(id);
-            this->modify(id);	
+            this->Modify(id);	
             return true;
         }
     }
@@ -61,23 +61,23 @@
 
 
 /* method description in header */
-bool ActionSet::remove(const ActionID &id, const QString & key)
+bool ActionSet::Remove(const ActionID &id, const QString & key)
 {
 
     Action *a;
 
     /* make sure an action exists before removing */
-    if ((a = this->action(id)))
+    if ((a = this->GetAction(id)))
     {
         /* if the key was removed from the action, then remove it from
          * the key list, and mark the action id as modified */
-        if (a->removeKey(key))
+        if (a->RemoveKey(key))
         {
             /* remove the action from the key map */
-            this->_keymap[key].remove(id);
+            this->m_KeyMap[key].remove(id);
 
             /* mark the action as modified */
-            this->modify(id);
+            this->Modify(id);
 
             return true;	    
         }
@@ -90,26 +90,26 @@
 
 
 /* method description in header */
-bool ActionSet::replace(const ActionID &id, const QString &newkey,
+bool ActionSet::Replace(const ActionID &id, const QString &newkey,
                         const QString &oldkey)
 {
     Action *a;
 
     /* make sure an action exists before replacing */
-    if ((a = this->action(id)))
+    if ((a = this->GetAction(id)))
     {
 
         /* make sure the key was actually replaced before modifying */
-        if (a->replaceKey(newkey, oldkey))
+        if (a->ReplaceKey(newkey, oldkey))
         {
             /* remove the action from the old key */
-            this->_keymap[oldkey].remove(id);
+            this->m_KeyMap[oldkey].remove(id);
 
             /* add the action to the new key */
-            this->_keymap[newkey].push_back(id);
+            this->m_KeyMap[newkey].push_back(id);
 
             /* mark the action as modified */
-            this->modify(id);
+            this->Modify(id);
 
             /* the job is done, return true */
             return true;	    
@@ -123,10 +123,10 @@
 
 
 /* method description in header */
-QStringList * ActionSet::contextStrings(void) const
+QStringList * ActionSet::ContextStrings(void) const
 {
     QStringList *context_strings = new QStringList();
-    QDictIterator<Context> it(_contexts);
+    QDictIterator<Context> it(m_Contexts);
 
     for (; it.current(); ++it)
         context_strings->append(it.currentKey());
@@ -137,15 +137,16 @@
 
 
 /* method description in header */
-QStringList * ActionSet::actionStrings(const QString &context_name) const
+QStringList * ActionSet::ActionStrings(const QString &context_name) const
 {
-    Context *c = _contexts[context_name];
+    Context *c = m_Contexts[context_name];
 
-    if (c == NULL) return NULL;
+    if (c == NULL)
+        return NULL;
     else
     {
         QStringList *action_strings = new QStringList();
-        QDictIterator<Action> it(*(_contexts[context_name]));
+        QDictIterator<Action> it(*(m_Contexts[context_name]));
 
         for (; it.current(); ++it)
             action_strings->append(it.currentKey());
@@ -154,54 +155,114 @@
     }
 }
 
+QStringList * ActionSet::GetAllKeys(void) const
+{
+    return new QStringList(this->m_KeyMap.keys());
+}
 
 
+QStringList * ActionSet::GetAllActions(void) const
+{
+    return new QStringList(this->m_Actions.keys());
+}
+
+
+QStringList * ActionSet::GetKeyContexts(const QString &key) const
+{
+    QStringList *strings = NULL;
+    const ActionList &ids = m_KeyMap[key];
+
+    if (ids.size() == 0)
+        return NULL;
+
+    strings = new QStringList();
+
+    for (size_t i = 0; i < ids.size(); i++)
+    {
+        if (!strings->contains(ids[i].context()))
+            strings->push_back(ids[i].context());
+    }
+
+    return strings;
+}
+
+
 /* method description in header */
-bool ActionSet::addAction(const ActionID &id, const QString &description,
+bool ActionSet::AddAction(const ActionID &id, const QString &description,
                           const QString &keys)
 {
-    if (!_contexts[id.context()]) _contexts.insert(id.context(),
-                                                   new Context());
+    if (!m_Contexts[id.context()])
+        m_Contexts.insert(id.context(), new Context());
 
     /* return false if the action already exists */
-    if ((*_contexts[id.context()])[id.action()]) return false;
+    if ((*m_Contexts[id.context()])[id.action()])
+        return false;
     else
     {
         /* create the action */
         Action *a = new Action(description, keys);
 
         /* add the action into the dict */
-        _contexts[id.context()]->insert(id.action(), a);
+        m_Contexts[id.context()]->insert(id.action(), a);
 
+        /* if the action doesn't already exist, then add it */
+        QStringList &contexts = m_Actions[id.action()];
+        if (!contexts.contains(id.context()))
+            contexts.push_back(id.context());
+
         /* get the actions keys */
-        const QStringList &keys = a->getKeys();
+        const QStringList &keys = a->GetKeys();
         for (size_t i = 0; i < keys.count(); i++)
         {
             /* get the action list (of actions bound to keys[i])
                if there is no key, keys[i], in the map, it will be added now */
-            ActionList &ids = _keymap[keys[i]];
+            ActionList &ids = m_KeyMap[keys[i]];
 
             /* add this action id to the list of actions bound to this key */
-            ids.push_back(id);
+            if (ids.size() == 0)
+                ids.push_back(id);
+            else
+            {
+                bool added = false;
+                ActionList::iterator it;
+
+                /* keep list sorted by action, then by context.  You
+                 * must sort this stuff because multiple actions from
+                 * different contexts can be added. Otherwise, we get
+                 * into trouble in keybindings.cpp and
+                 * mythcontrols.cpp when trying to delete based on
+                 * action (displayed by key) */
+                for (it = ids.begin(); (it != ids.end()) && (added == false);
+                     ++it)
+                {
+                    if ((QString::compare(id.action(), (*it).action()) < 0) ||
+                        ((QString::compare(id.action(), (*it).action()) == 0) &&
+                         (QString::compare(id.context(), (*it).context()) < 0)))
+                    {
+                        ids.insert(it, id);
+                        added = true;
+                        break;
+                    }
+                }
+                if (added == false) ids.push_back(id);
+            }
         }
-
         return true;
     }
-
     return false;
 }
 
 
 
-QString ActionSet::keyString(const ActionID &id) const
+QString ActionSet::KeyString(const ActionID &id) const
 {
     Context *c;
-    if ((c = _contexts[id.context()]))
+    if ((c = m_Contexts[id.context()]))
     {
         Action *a;
         if ((a = (*c)[id.action()]))
         {
-            return a->keyString();
+            return a->KeyString();
         }
     }
     return QString::null;
@@ -209,44 +270,31 @@
 
 
 
-QStringList ActionSet::getKeys(const ActionID &id) const
+QStringList ActionSet::GetKeys(const ActionID &id) const
 {
     Context *c;
-    if ((c = _contexts[id.context()]))
+    if ((c = m_Contexts[id.context()]))
     {
         Action *a;
         if ((a = (*c)[id.action()]))
-        {
-            return a->getKeys();
-        }
+            return a->GetKeys();
     }
 
     return QStringList();
 }
 
 
-
-const QString & ActionSet::getDescription(const ActionID &id) const
+const QString & ActionSet::GetDescription(const ActionID &id) const
 {
     Context *c;
-    if ((c = _contexts[id.context()]))
+    if ((c = m_Contexts[id.context()]))
     {
         Action *a;
         if ((a = (*c)[id.action()]))
-        {
-            return a->getDescription();
-        }
+            return a->GetDescription();
     }
 
     return QString::null;
 }
 
-
-
-const ActionList & ActionSet::getActions(const QString &key) const
-{
-    return _keymap[key];
-}
-
-
 #endif /* ACTIONSET_CPP */
Index: mythcontrols/mythcontrols.h
===================================================================
--- mythcontrols/mythcontrols.h	(revision 10604)
+++ mythcontrols/mythcontrols.h	(working copy)
@@ -29,17 +29,6 @@
 
 #include "keybindings.h"
 
-typedef struct
-{
-    QString key;
-    QString context;
-    QString contextFrom;
-    QString action;
-    int bindlevel;
-} binding_t;
-
-typedef QPtrList<binding_t> BindingList;
-
 /**
  * @class MythControls
  * @brief The myth controls configuration class.
@@ -51,7 +40,8 @@
 
 public:
     /**
-     * @brief Create a new myth controls wizard.
+     * Create a new myth controls wizard.
+     *
      * @param parent The main myth window.
      * @param name The name of this window?  I dunno, none of the docs
      * say.
@@ -60,197 +50,214 @@
      */
     MythControls(MythMainWindow *parent, bool& ui_ok);
 
-    /**
-     * @brief Delete the myth controls object.
-     */
+    /** Delete the myth controls object. */
     ~MythControls();
 
     /**
-     * @brief Get the currently selected context string.
+     * Get the currently selected context string. If no context is
+     * selected, an empty string is returned.
+     *
      * @return The currently selected context string.
-     *
-     * If no context is selected, an empty string is returned.
      */
-    QString getCurrentContext(void) const;
+    QString GetCurrentContext(void) const;
 
     /**
-     * @brief Get the currently selected action string.
+     * Get the currently selected action string. If no action is
+     * selected, an empty string is returned.
+     *
      * @return The currently selected action string.
-     *
-     * If no action is selected, an empty string is returned.
      */
-    QString getCurrentAction(void) const;
+    QString GetCurrentAction(void) const;
 
     /**
-     * @brief Get the currently selected key string
+     * Get the currently selected key string.  If no context is
+     * selected, an empty string is returned.
+     *
      * @return The currently selected key string
-     *
-     * If no context is selected, an empty string is returned.
      */
-    QString getCurrentKey(void) const;
+    QString GetCurrentKey(void) const;
 
-    
-    
 protected:
 
+
+    /** The view mode */
+    typedef enum { ActionsByContext, ActionsByKey, ContextsByKey } ViewMode;
+
     /**
-     * @brief Load up UI.
-     * @return true if all UI elements were loaded successfully,
-     * otherwise false it returned.
+     * Load up UI.
      *
-     * This method grabs all of the UI "thingies" that are needed by
-     * mythcontrols.  If this method returns false, the plugin should
-     * exit since it will probably just core dump.
+     * @return true if all UI elements were loaded successfully
      */
-    bool loadUI();
+    bool LoadUI();
 
     /**
+     * Show or hide the buttons at the bottom.
+     *
+     * @param shown Should the buttons be shown?
+     */
+    void ShowButtons(bool shown) const;
+
+    /**
+     * Blank the text in the bottom buttons.
+     */
+    void BlankButtons(void) const;
+
+    /**
+     * Fill the buttons with the strings in a string list.
+     * @param strings The string list.
+     */
+    void FillButtons(const QStringList & strings);
+
+    /**
+     * Set the viewing mode of the plugin.
+     *
+     * @param view The view mode.
+     * @param force Force the view to be set (or reset)
+     */
+    void SetView(ViewMode newview, bool force=false);
+
+    /**
      * @brief The key press handler.
      * @param e The key event.
      */
     void keyPressEvent(QKeyEvent *e);
 
     /**
-     * @brief Redraw the key information
+     * Refresh the action description and key binding buttons.
+     */
+    void RefreshBindingInformation();
+
+    /**
+     * @brief Redraw the information at the bottom.
+     */
+    void RefreshInformation();
+
+    /**
+     * Refresh the right list.
      *
-     * Updates the list of keys that are shown and the description of
-     * the action.
+     * @param strings The strings to place in the right list.
      */
-    void refreshKeyInformation();
+    void RefreshRight(QStringList * strings);
 
     /**
-     * @brief Load the appropriate actions into the action list.
-     * @param context The context, from which actions will be
-     * displayed.
+     * Refresh the left list.
+     *
+     * @param string The strings to place in the left list.
      */
-    void refreshRightList(void);
+    void RefreshLeft(QStringList * strings);
 
     /**
-     * @brief Redisplay both the left and right lists and fix focus
+     * Load the appropriate information into the right list.
+     *
+     * @param strings The strings to load into the right list.
      */
-    void updateLists(void);
+    void RefreshRightList();
 
+    /** Redisplay both the left and right lists and fix focus */
+    void UpdateLists(void);
+
     /**
-     * @brief Load the settings for a particular host.
+     * Load the settings for a particular host.
+     *
      * @param hostname The host to load settings for.
      */
-    void loadHost(const QString & hostname);
+    void LoadHost(const QString & hostname);
 
     /**
-     * @brief Focus a button in a particular direction.
+     * Focus a button in a particular direction.
+     *
      * @param direction Positave values focus to the right, negatives
      * to the left.  A value of zero focuses the first button.
      */
-    void focusButton(int direction);
+    void FocusButton(int direction);
 
     /**
-     * @brief Determine which button is focused.
+     * Determine which button is focused.
+     *
      * @return Action::MAX_KEYS is no button is focused, otherwise, the
      * index of the button is returned.
-     *
-     * @sa Action::MAX_KEYS
      */
-    size_t focusedButton(void) const;
+    size_t FocusedButton(void) const;
 
     /**
-     * @brief Resolve a potential conflict.
+     * Resolve a potential conflict.
+     *
      * @return true if the conflict should be bound, otherwise, false
      * is returned.
      */
-    bool resolveConflict(ActionID *conflict, int level);
+    bool ResolveConflict(ActionID *conflict, int level);
 
     /**
-     * @brief Focus a new list and take focus away from the old.
+     * Focus a new list and take focus away from the old.
+     *
      * @param focus The list to gain focus
      * @param unfocus The list to loose focus
      */
-    void switchListFocus(UIListBtnType *focus, UIListBtnType *unfocus);
+    void SwitchListFocus(UIListBtnType *focus, UIListBtnType *unfocus);
 
-    /**
-     * @brief Add bindings to QDict<binding_t> for specified context
-     * @param bindings the QDict to which to add the bindings
-     * @param context the context to grab keybindings from
-     * @param contextParent the context whose keybindings are being calculated
-     * @param bindlevel the bind level associated with this context
-     */
-    void addBindings(QDict<binding_t> &bindings, const QString &context, const QString &contextParent, int bindlevel);
-
-    /**
-     * @brief Create a BindingList for the specified context
-     * @param context the context for which a BindingList should be created
-     */
-    BindingList *getKeyBindings(const QString &context);
-
 private slots:
 
-/**
- * @brief Add a key to the currently selected action.
- */
-void addKeyToAction(void);
+	/** Add a key to the currently selected action. */
+	void AddKeyToAction(void);
 
-    /**
-     * @brief Delete the currently active key.
-     */
-    void deleteKey();
+    /** Delete the currently active key. */
+    void DeleteKey();
 
-    /**
-     * @brief Save the settings.
-     */
-    inline void save(void) { key_bindings->commitChanges(); }
+    /** Save the settings. */
+    inline void Save(void)
+    {
+       m_KeyBindings->CommitChanges();
+    }
 
     /**
-     * @brief Recieves a signal when an item in the left list is
-     * selected.
+     * Recieves a signal when an item in the left list is selected.
+     *
      * @param item The selected item.
      */
-    void leftSelected(UIListBtnTypeItem *item);
+    void LeftSelected(UIListBtnTypeItem *item);
 
     /**
-     * @brief Recieves a signal when an item in the right list is
-     * selected.
+     * Recieves a signal when an item in the right list is selected.
+     *
      * @param item The selected item.
      */
-    void rightSelected(UIListBtnTypeItem *item);
+    void RightSelected(UIListBtnTypeItem *item);
 
-    /**
-     * @brief Sort a list of keys, removing duplicates
-     * @param keys the list of keys to sort
-     */
-    void sortKeyList(QStringList &keys);
+    /** Refresh binding information */
+    void RefreshKeyBindings();
 
     /**
-     * @brief Refresh binding information
-     */
-    void refreshKeyBindings();
-
-    /**
-     * @brief Jump to a particular key binding
+     * Jump to a particular key binding
+     *
      * @param e key event to use as jump
      */
     bool JumpTo(QKeyEvent *e);
 
 private:
 
-    UIType *focused;
-    UIListBtnType *LeftList;
-    UIListBtnType *RightList;
-    UITextType *description, *LeftDesc, *RightDesc;
-    UITextButtonType * ActionButtons[Action::MAX_KEYS];
-    KeyBindings *key_bindings;
-    LayerSet *container;
+    /** Currently focused UI type */
+    UIType *m_Focused;
 
-    QStringList contexts; ///< sorted list of contexts
-    QStringList keys; ///< sorted list of keys
+    /** The left list */
+    UIListBtnType *m_LeftList;
 
-    QDict<QStringList> m_contexts; ///< actions for a given context
-    QDict<BindingList> contextKeys; ///< key bindings for a given context
-    QDict<BindingList> keyActions; ///< actions in each context for a given key
+    /** The right list */
+    UIListBtnType *m_RightList;
 
-    typedef enum { kContextList, kKeyList, kActionList } ListType;
-    ListType leftType, rightType;
+    /** Text areas */
+    UITextType *m_Description, *m_LeftDesc, *m_RightDesc;
 
-    QString getTypeDesc(ListType type);
+    /** Buttons */
+    UITextButtonType * m_ActionButtons[Action::MAX_KEYS];
 
+    /** The current keybindings */
+    KeyBindings *m_KeyBindings;
+
+    /** A layer contianer */
+    LayerSet *m_Container;
+
+    /** The view mode */
+    ViewMode m_View;
 };
 
 
